/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// AR_MAP.C

#include "KD_DEF.H"
#pragma	hdrstop

/*
=============================================================================

LOCAL CONSTANTS

=============================================================================
*/


/*
=============================================================================

GLOBAL VARIABLES

=============================================================================
*/

CK_action CK5_ACT_MapKeenStart = { 0x0, 0x0, AT_UnscaledFrame, 0x0, 0x0, 0x168, 0x0, 0x0, CK5_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenWave0};
CK_action CK5_ACT_MapKeenWave0 = { WORLDKEENWAVE1SPR, WORLDKEENWAVE1SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK5_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenWave1};
CK_action CK5_ACT_MapKeenWave1 = { WORLDKEENWAVE2SPR, WORLDKEENWAVE2SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK5_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenWave2};
CK_action CK5_ACT_MapKeenWave2 = { WORLDKEENWAVE1SPR, WORLDKEENWAVE1SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK5_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenWave3};
CK_action CK5_ACT_MapKeenWave3 = { WORLDKEENWAVE2SPR, WORLDKEENWAVE2SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK5_MapKeenStill, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenWave4};
CK_action CK5_ACT_MapKeenWave4 = { WORLDKEENWAVE1SPR, WORLDKEENWAVE1SPR, AT_UnscaledFrame, 0x0, 0x0, 0x14, 0x0, 0x0, CK5_MapKeenWalk, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenStart};
CK_action CK5_ACT_MapKeenWalk0 = { 0x0, 0x0, AT_ScaledOnce, 0x1, 0x0, 0x4, 0x18, 0x18, CK5_MapKeenWalk, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapKeenWalk0};


//===========================================================================
//
// DEMO SIGN
//
//===========================================================================


//===========================================================================
//
// SCORE BOX
//
//===========================================================================


//===========================================================================
//
// MAP KEEN
//
//===========================================================================


static int ck_mapKeenFrames[] ={ WORLDKEENU1SPR-1, WORLDKEENUR1SPR-1, WORLDKEENR1SPR-1, WORLDKEENDR1SPR-1, WORLDKEEND1SPR-1, WORLDKEENDL1SPR-1, WORLDKEENL1SPR-1, WORLDKEENUL1SPR-1 };
static int word_417BA[] ={ 2, 3, 1, 3}; 

void CK_SpawnMapKeen(int tileX, int tileY)
{

	ck_keenObj->type = 2;
	if (ck_gameState.mapPosX == 0)
	{
		ck_keenObj->posX = (tileX << 8);
		ck_keenObj->posY = (tileY << 8);
	}
	else
	{
		ck_keenObj->posX = ck_gameState.mapPosX;
		ck_keenObj->posY = ck_gameState.mapPosY;
	}

	ck_keenObj->active = OBJ_ALWAYS_ACTIVE;
	ck_keenObj->zLayer = 1;
	ck_keenObj->xDirection= ck_keenObj->yDirection = motion_None;
	ck_keenObj->user1 = 6;
	ck_keenObj->user2 = 3;
	ck_keenObj->user3 = 0;
	ck_keenObj->gfxChunk = WORLDKEENDR1SPR;
	CK_SetAction(ck_keenObj, &CK5_ACT_MapKeenStart);
}



//look for level entrry

void CK5_ScanForLevelEntry(CK_object * obj)
{

	int tx, ty;
	int tileY_0 = obj->clipRects.tileY1;

	for (ty = obj->clipRects.tileY1; ty <= obj->clipRects.tileY2; ty++)
	{
		for (tx = obj->clipRects.tileX1; tx <= obj->clipRects.tileX2; tx++)
		{
			unsigned infotile =CA_TileAtPos(tx, ty, 2);
			if (infotile > 0xC000 && infotile <= 0xC019)
			{
				// Vanilla keen stores the current map loaded in the cache manager
				// and the "current_map" variable stored in the gamestate
				// would have been changed here.
				ck_gameState.mapPosX = obj->posX;
				ck_gameState.mapPosY = obj->posY;
				ck_gameState.currentLevel = infotile - 0xC000;
				ck_levelState = LS_LevelComplete;
				SD_PlaySound(LEVELSTARTSND);
				return;
			}
		}
	}
}

void CK5_MapKeenStill(CK_object * obj)
{

	if (ck_inputFrame.dir != dir_None)
	{
		obj->currentAction = &CK5_ACT_MapKeenWalk0;
		obj->user2 = 0;
		CK5_MapKeenWalk(obj);
	}

	if (ck_keenState.jumpIsPressed || ck_keenState.pogoIsPressed || ck_keenState.shootIsPressed)
	{
		CK5_ScanForLevelEntry(obj);
	}
}

// user1 = last dir;
// user2 = walking frame ticker
// user3 = 
void CK5_MapKeenWalk(CK_object * obj)
{

	if (obj->user3 == 0)
	{
		obj->xDirection = ck_inputFrame.xaxis;
		obj->yDirection = ck_inputFrame.yaxis;
		if (ck_keenState.pogoIsPressed || ck_keenState.jumpIsPressed || ck_keenState.shootIsPressed)
			CK5_ScanForLevelEntry(obj);

		// Go back to standing if no arrows pressed
		if (ck_inputFrame.dir == dir_None)
		{
			obj->currentAction = &CK5_ACT_MapKeenStart;
			obj->gfxChunk = ck_mapKeenFrames[obj->user1] + 3;
			return;
		}
		else
		{
			obj->user1 = ck_inputFrame.dir;
		}
	}
	else
	{
		if ((obj->user3 -= 4) < 0)
			obj->user3 = 0;
	}

	// Advance Walking Frame Animation
	if (++obj->user2 == 4)
		obj->user2 = 0;
	obj->gfxChunk = ck_mapKeenFrames[obj->user1] + word_417BA[obj->user2];

	//walk hi lo sound
	if (obj->user2 == 1)
	{
		SD_PlaySound(KEENWALK0SND);
	}
	else if (obj->user2 == 3)
	{
		SD_PlaySound(KEENWALK1SND);
	}
}



void CK_MapMiscFlagsCheck(CK_object *keen)
{

	int midTileX, midTileY;

	if (keen->user3)
		return;

	midTileX = keen->clipRects.tileXmid;
	midTileY = ((keen->clipRects.unitY2 - keen->clipRects.unitY1) / 2 + keen->clipRects.unitY1) >> 8;

	switch (TI_ForeMisc(CA_TileAtPos(midTileX, midTileY, 1)))
	{

		// Water tile
	case 11:
	case 12:
	case 13:
	case 14:
		SD_PlaySound(NOWAYSND);
		AR_GeneratorMapMessage();
		RF_ForceRefresh();
		ck_nextX = -keen->deltaPosX;
		ck_nextY = -keen->deltaPosY;
		keen->xDirection = keen->yDirection = motion_None;
		CK_PhysUpdateNormalObj(keen);
	}
}

//===========================================================================
//
// MAP FLAGS
// 
//===========================================================================

CK_action CK5_ACT_MapFlagFlips0 ;
CK_action CK5_ACT_MapFlagFlips1 ;
CK_action CK5_ACT_MapFlagFlips2 ;
CK_action CK5_ACT_MapFlagFlips3 ;
CK_action CK5_ACT_MapFlagFlips4 ;
CK_action CK5_ACT_MapFlagFlips5 ;
CK_action CK5_ACT_MapFlagFlips6 ;


CK_action CK5_ACT_MapFlag0 ;
CK_action CK5_ACT_MapFlag1 ;
CK_action CK5_ACT_MapFlag2 ;
CK_action CK5_ACT_MapFlag3 ;

void CK_MapFlagSpawn(unsigned tileX, unsigned tileY);
void CK_SpawnFlippingFlag(unsigned tileX, unsigned tileY);
void CK_KeenFlagThrown (CK_object *obj);
void CK_KeenFlagSearch (CK_object *obj);
void CK_KeenFlagLands(CK_object *obj);


CK_action CK5_ACT_MapFlagFlips0 = { FLAGFLIP1SPR, FLAGFLIP1SPR, AT_Frame, 0, 0, 6, 0, 0, CK_KeenFlagThrown, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlagFlips1};
CK_action CK5_ACT_MapFlagFlips1 = { FLAGFLIP1SPR, FLAGFLIP1SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlagFlips2};
CK_action CK5_ACT_MapFlagFlips2 = { FLAGFLIP2SPR, FLAGFLIP2SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlagFlips3};
CK_action CK5_ACT_MapFlagFlips3 = { FLAGFLIP3SPR, FLAGFLIP3SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlagFlips4};
CK_action CK5_ACT_MapFlagFlips4 = { FLAGFLIP4SPR, FLAGFLIP4SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlagFlips5};
CK_action CK5_ACT_MapFlagFlips5 = { FLAGFLIP6SPR, FLAGFLIP6SPR, AT_UnscaledFrame, 0, 0, 12, 0, 0, CK_KeenFlagSearch, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlagFlips6};	// K1n9_Duk3 fix: Keen 4-6 use FLAGFLIP6SPR here, not FLAGFLIP4SPR
CK_action CK5_ACT_MapFlagFlips6 = { FLAGFLIP6SPR, FLAGFLIP6SPR, AT_UnscaledFrame, true, 0, 1, 0, 0, CK_KeenFlagLands, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlag0};


CK_action CK5_ACT_MapFlag0 = { FLAGWAVE1SPR, FLAGWAVE1SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlag1};
CK_action CK5_ACT_MapFlag1 = { FLAGWAVE2SPR, FLAGWAVE2SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlag2};
CK_action CK5_ACT_MapFlag2 = { FLAGWAVE3SPR, FLAGWAVE3SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlag3};
CK_action CK5_ACT_MapFlag3 = { FLAGWAVE4SPR, FLAGWAVE4SPR, AT_UnscaledOnce, 0x0, 0x0, 0xa, 0x0, 0x0, NULL, NULL, CK_BasicDrawFunc1, &CK5_ACT_MapFlag0};

void CK_MapFlagSpawn(unsigned tileX, unsigned tileY)
{

	CK_object *flag = CK_GetNewObj(false);

	flag->clipped = CLIP_not;
	flag->zLayer = PRIORITIES-1;
	flag->type = CT_MapFlag;
	flag->active = OBJ_ACTIVE;
	flag->posX = (tileX << 8) + 0x60;
	flag->posY = (tileY << 8) - 0x1E0;
	flag->actionTimer = US_RndT() / 16;
	CK_SetAction(flag, &CK5_ACT_MapFlag0);
}

typedef struct {
	unsigned x, y;
} flagpointtype;

flagpointtype flagpoints[30];

void CK_SpawnFlippingFlag(unsigned tileX, unsigned tileY)
{

	CK_object *newobj;
	long deltaX, deltaY;
	int i;

	newobj = CK_GetNewObj(false);
	newobj->clipped = CLIP_not;
	newobj->zLayer = PRIORITIES - 1;
	newobj->type = CT_MapFlag;
	newobj->active = OBJ_ALWAYS_ACTIVE;
	newobj->posX = ck_gameState.mapPosX - 0x100;
	newobj->posY = ck_gameState.mapPosY - 0x100;

	// Destination coordinates
	newobj->user1 = (tileX<<G_T_SHIFT) + 0x60;
	newobj->user2 = (tileY<<G_T_SHIFT) - 0x260;
	
	deltaX = (long)newobj->user1 - (long)newobj->posX;
	deltaY = (long)newobj->user2 - (long)newobj->posY;

	// Make a table of coordinates for the flag's path
	for (i = 0; i < 30; i++)
	{

		// Draw points in a straight line between keen and the holster
		flagpoints[i].x = newobj->posX + deltaX*(i<24?i:24)/24;
		flagpoints[i].y = newobj->posY + deltaY*i/30;

		// Offset the Y points to mimic a parabolic trajectory
		if (i < 10)      // going up
			flagpoints[i].y -= i * 0x30;
		else if (i < 15) // starts to arc
			flagpoints[i].y -= i * 16 + 0x140;
		else if (i < 20) // flag starts falling
			flagpoints[i].y -= (20 - i) * 16 + 0x1E0;
		else 		// starts falling faster
			flagpoints[i].y -= (29 - i) * 0x30;
	}

	CK_SetAction(newobj, &CK5_ACT_MapFlagFlips0);
}



void CK_KeenFlagThrown (CK_object *obj)
{
	// Start the throw when screen becomes light
	if (!screenfaded)
	{
		SD_StopSound();
		SD_PlaySound(0x2B);
		obj->currentAction = obj->currentAction->next;
	}
}


void CK_KeenFlagSearch (CK_object *obj)
{
	obj->user3 += tics;

	if (obj->user3 > 58)
		obj->user3 = 58;

	// Move the flag along the path
	obj->posX = flagpoints[obj->user3/2].x;
	obj->posY = flagpoints[obj->user3/2].y;

	obj->visible = true;
	if (!obj->user1)
		SD_PlaySound(0x2B);
}

void CK_KeenFlagLands(CK_object *obj)
{

	// Put the flag in its holster
	obj->posX = obj->user1;
	obj->posY = obj->user2 + 0x80;
	obj->zLayer = PRIORITIES - 1;

	SD_PlaySound(0x2C);
}

//===========================================================================
//
// TRANSPORTER
// 
//===========================================================================

CK_action AR_ACT_TransporterKeen1;
CK_action AR_ACT_TransporterKeen2;

void AR_SpawnTransporterKeen(unsigned tileX, unsigned tileY);
void AR_TransporterKeen(CK_object *obj);

CK_action AR_ACT_TransporterKeen1 = { KEENSAUCER1SPR, KEENSAUCER1SPR, AT_UnscaledFrame, 0, 0, 6, 0, 0, AR_TransporterKeen, NULL, CK_BasicDrawFunc1, &AR_ACT_TransporterKeen2};
CK_action AR_ACT_TransporterKeen2 = { KEENSAUCER2SPR, KEENSAUCER2SPR, AT_UnscaledFrame, 0, 0, 6, 0, 0, AR_TransporterKeen, NULL, CK_BasicDrawFunc1, &AR_ACT_TransporterKeen1};

void AR_SpawnTransporterKeen(unsigned tileX, unsigned tileY) 
{
	unsigned info;
	long delX, delY, destX, destY;
	int velX, velY;

	ck_keenObj->clipped = CLIP_not;
	ck_keenObj->active = OBJ_ALWAYS_ACTIVE;
	ck_keenObj->posX = tileX << G_T_SHIFT;
	ck_keenObj->posY = tileY << G_T_SHIFT;
	ck_keenObj->zLayer = 2;

	// Destination in infoplane
	info = *((unsigned _seg *)mapsegs[2] + mapbwidthtable[tileY]/2 + tileX-1); 
	
	destX = (ck_keenObj->user1 = info >> 8) << G_T_SHIFT;
	destY = (ck_keenObj->user2 = info & 0xFF) << G_T_SHIFT;

	delX = destX - ck_keenObj->posX;
	delY = destY - ck_keenObj->posY;

	if (abs(delX) > abs(delY))
	{
		velX = delX>0?0x2000 : -0x2000; 
		velY = delY * velX / delX;
	}
	else
	{
		velY = delY>0?0x2000 : -0x2000;
		velX = delX * velY / delY;
	}

	ck_keenObj->velX = velX;
	ck_keenObj->velY = velY;

	CK_SetAction(ck_keenObj,  &AR_ACT_TransporterKeen1);

}

void AR_TransporterKeen(CK_object *obj)
{
	unsigned tileX, tileY;

	tileX = obj->posX >> G_T_SHIFT;
	tileY = obj->posY >> G_T_SHIFT;

	if (obj->user1-1 <= tileX && tileX <= obj->user1+1 && 
	 obj->user2-1 <= tileY && tileY <= obj->user2+1) 
	{
		obj->zLayer = 1;
		obj->xDirection= obj->yDirection = motion_None;
		obj->user1 = 6;
		obj->user2 = 3;
		obj->user3 = 0;
		obj->gfxChunk = WORLDKEENDR1SPR;
		obj->clipped = CLIP_normal;
		CK_SetAction2(obj, &CK5_ACT_MapKeenStart);
		return;
	}

	ck_nextX = obj->velX/0x100 * tics;
	ck_nextY = obj->velY/0x100 * tics;

}

