/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// AR_MISC.C

#include "KD_DEF.H"
#pragma	hdrstop

/*
=============================================================================

LOCAL CONSTANTS

=============================================================================
*/

CK_action AR_ACT_3UP;
CK_action AR_ACT_3UP2;



/*
=============================================================================

GLOBAL VARIABLES

=============================================================================
*/
CK_action CK5_act_redAxisPlatform = {SPR_PLATFORM, SPR_PLATFORM, AT_Frame, 0, 0, 0, 0, 0, CK5_RedAxisPlatform, NULL, CK_BasicDrawFunc1, NULL };

CK_action CK5_act_item = {0, 0, AT_UnscaledOnce, 0, 0, 20, 0, 0, CK5_PointItem, NULL, CK_BasicDrawFunc1, &CK5_act_item2};
CK_action CK5_act_item2 = {0, 0, AT_UnscaledOnce, 0, 0, 20, 0, 0, CK5_PointItem, NULL, CK_BasicDrawFunc1, &CK5_act_item};

CK_action AR_ACT_3UP = {0, 0, AT_UnscaledOnce, 0, 0, 13, 0, 0, CK5_PointItem, NULL, CK_BasicDrawFunc1, &AR_ACT_3UP2};
CK_action AR_ACT_3UP2 = {0, 0, AT_UnscaledOnce, 0, 0, 13, 0, 0, CK5_PointItem, NULL, CK_BasicDrawFunc1, &AR_ACT_3UP};


CK_action CK_ACT_VitalinNotify1 = {VITALINBURST1SPR, VITALINBURST1SPR, AT_UnscaledOnce, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_VitalinNotify2};
CK_action CK_ACT_VitalinNotify2 = {VITALINBURST2SPR, VITALINBURST2SPR, AT_UnscaledOnce, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_VitalinNotify3};
CK_action CK_ACT_VitalinNotify3 = {VITALINBURST3SPR, VITALINBURST3SPR, AT_UnscaledOnce, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, NULL};

CK_action CK5_ACT_FallPlat0 = {SPR_PLATFORM, SPR_PLATFORM, AT_Frame, 0x0, 0x0, 0x0, 0x0, 0x0, CK5_FallPlatSit, NULL, CK_BasicDrawFunc1, NULL};
CK_action CK5_ACT_FallPlat1 = {SPR_PLATFORM, SPR_PLATFORM, AT_Frame, 0x0, 0x0, 0x0, 0x0, 0x0, CK5_FallPlatFall, NULL, CK_BasicDrawFunc1, NULL};
CK_action CK5_ACT_FallPlat2 = {SPR_PLATFORM, SPR_PLATFORM, AT_ScaledFrame, 0x0, 0x0, 0x0, 0x0, -32, CK5_FallPlatRise, NULL, CK_BasicDrawFunc1, NULL};

CK_action CK5_ACT_redStandPlatform = {SPR_PLATFORM, SPR_PLATFORM, AT_UnscaledOnce, 0, 0, 32000, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &CK5_ACT_redStandPlatform};

const char *ck_levelNames[] = {

	"Krisle",
	"Dark Swamp",
	"Murky Marsh",
	"Larvae Lagoon",
	"Crystallite Caverns",
	"Emerald Canyon",
	"Atroxian Mines ",
	"Atroxian Base",
	"Security Layer",
	"Port Atrox",
	"Hornet Hive",
	"Brithom Bog",
	"Kridonea Gateway",
	"Krilewood Forest",
	"The Catacombs",
	"Great Ziggurat",
	"Sky Sanctum",
	"Realm Reactor",
	"Crystal Sanctuary",
	"High Scores",
	"Kridonea Ruins",
	"Kridonea Ruins",
	"Cargo Transit A",
	"Cargo Transit B",
	"Crystalcomb Hive",
	"BWB Crash Site",
};

// HACK: Sorry, the strings need to be in WRITABLE storage,
// because US_CPrint (temporarily) modifies them.


char ck_levelEntryText_0[] =
	"Keen searches\n planet Krisle";

char ck_levelEntryText_0b[] =
	"Keen prepares for\nhis final battle";

char ck_levelEntryText_1[] =
	"Keen explores the \n Dark Swamp";

char ck_levelEntryText_2[] =
	"Keen marches\n into Murky Marsh";

char ck_levelEntryText_3[] =
	"Keen lurks in\n the Larvae Lagoon";

char ck_levelEntryText_4[] =
	"Keen climbs through\nCrystallite Caverns";

char ck_levelEntryText_5[] =
	"Keen plummets down\n Emerald Canyon";

char ck_levelEntryText_6[] =
	"Keen infiltrates the\n Atroxian Mines";

char ck_levelEntryText_7[] =
	"Keen attacks the\n Atroxian Base";

char ck_levelEntryText_8[] =
	"Keen sneaks through\n the Security Layer";

char ck_levelEntryText_9[] =
	"Keen breaks into\n Port Atrox";

char ck_levelEntryText_10[] =
	"Keen swarms into\n the Hornet Hive";

char ck_levelEntryText_11[] =
	"Keen bobs through\n Brithom Bog";

char ck_levelEntryText_12[] =
	"Keen discovers the\n Kridonea Gateway";

char ck_levelEntryText_13[] =
	"Keen enters the \nKrilewood Forest";

char ck_levelEntryText_14[] =
	"Keen battles through\nThe Catacombs";

char ck_levelEntryText_15[] =
	"Keen reverently enters\nthe Great Ziggurat";

char ck_levelEntryText_16[] =
	"Keen anxiously ascends\nthe Sky Sanctum";

char ck_levelEntryText_17[] =
	"Keen battles Atroxus\n at the\nRealm Reactor";

char ck_levelEntryText_18[] =
	"Keen scales the\nCrystal Sanctuary";

char ck_levelEntryText_19[] =
	"Keen tallies the\nHigh Scores";

char ck_levelEntryText_20[] =
	"Keen enters the\nKridonea Ruins";

char ck_levelEntryText_21[] =
	"Keen continues through\nthe Kridonea Ruins";

char ck_levelEntryText_22[] =
	"Keen zips through\n Cargo Transit A";

char ck_levelEntryText_23[] =
	"Keen zips through\n Cargo Transit B";

char ck_levelEntryText_24[] =
	"Keen combs through\n Crystalcomb Hive";

char ck_levelEntryText_25[] =
	"Keen explores the\nBWB Megarocket\ncrash site";

char ck_levelEntryText_25b[] =
	"Keen returns to the\nBWB Megarocket\ncrash site";


char *ck_levelEntryTexts[] = {
	ck_levelEntryText_0,
	ck_levelEntryText_1,
	ck_levelEntryText_2,
	ck_levelEntryText_3,
	ck_levelEntryText_4,
	ck_levelEntryText_5,
	ck_levelEntryText_6,
	ck_levelEntryText_7,
	ck_levelEntryText_8,
	ck_levelEntryText_9,
	ck_levelEntryText_10,
	ck_levelEntryText_11,
	ck_levelEntryText_12,
	ck_levelEntryText_13,
	ck_levelEntryText_14,
	ck_levelEntryText_15,
	ck_levelEntryText_16,
	ck_levelEntryText_17,
	ck_levelEntryText_18,
	ck_levelEntryText_19,
	ck_levelEntryText_20,
	ck_levelEntryText_21,
	ck_levelEntryText_22,
	ck_levelEntryText_23,
	ck_levelEntryText_24,
	ck_levelEntryText_25,
};
/*
=============================================================================

LOCAL VARIABLES

=============================================================================
*/

void CK_ObjBadState (void);
void AR_SpawnCheckPoint (unsigned x, unsigned y);

/*
=============================================================================

						 SCORE BOX ROUTINES

=============================================================================
*/

void	SpawnScore (void);
void CK_UpdateScoreBox (CK_object *ob);
void ScoreReact (CK_object *ob);

void MemDrawChar (int char8,byte far *dest,unsigned width,unsigned planesize);

CK_action CK_ACT_ScoreBox = {NULL,NULL,AT_Frame,false, false,0, 0,0, NULL , NULL, NULL, NULL};
CK_action CK_ACT_DemoSign = {DEMOSIGNSPR,DEMOSIGNSPR,AT_Frame,false, false,0, 0,0, NULL , NULL, NULL, NULL};

CK_action CK_ACT_Null = {0, 0, AT_Frame, false, false, 0, 0, 0, (void (*)(CK_object *))CK_ObjBadState, (void (*)(CK_object *, CK_object *))CK_ObjBadState, (void (*)(CK_object *))CK_ObjBadState, NULL};

/*
======================
=
= SpawnScore
=
======================
*/

void	SpawnScore (void)
{
	ck_scoreBoxObj->type = CT_Friendly;
	ck_scoreBoxObj->active = OBJ_ALWAYS_ACTIVE;
	ck_scoreBoxObj->clipped = false;
	*((long *)&(ck_scoreBoxObj->user1)) = -1L;	// force score to be updated
	ck_scoreBoxObj->user3 = -1;			// and shots
	ck_scoreBoxObj->user4 = -1;			// and lives

	if (ck_inHighScores)
	{
		// Don't display anything in the high scores
		//ck_scoreBoxObj->currentAction = NULL;	// EXTREMELY bad idea! NULL actions will cause errors, at least on real hardware.
		CK_SetAction(ck_scoreBoxObj, &CK_ACT_ScoreBox);	// K1n9_Duk3 fix (this state doesn't do anything anyway)
	}
	else if (DemoMode)
	{
		// If this is a demo, display the DEMO banner
		CK_SetAction(ck_scoreBoxObj, &CK_ACT_DemoSign);
		CA_CacheGrChunk(DEMOSIGNSPR);
	}
	else
	{
		// If a normal game, display the scorebox 
		CK_SetAction(ck_scoreBoxObj, &CK_ACT_ScoreBox);
	}
}

void CK_DemoSign( CK_object *demo)
{
	if (	demo->posX == originxglobal && demo->posY == originyglobal ) 
		return;
	demo->posX = originxglobal;
	demo->posY = originyglobal;

	//place demo sprite in center top
	RF_PlaceSprite( &(demo->sde), demo->posX+0x0A00 - 0x200, demo->posY+0x80,DEMOSIGNSPR,false,3);
}


/*
======================
=
= MemDrawChar
=
======================
*/

#if GRMODE == EGAGR

void MemDrawChar (int char8,byte far *dest,unsigned width,unsigned planesize)
{

void _seg *tile8seg = grsegs[STARTTILE8];

asm	mov	si,[char8]
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1		// index into char 8 segment

asm	mov	ds,[WORD PTR tile8seg]
asm	mov	es,[WORD PTR dest+2]

asm	mov	cx,4		// draw four planes
asm	mov	bx,[width]
asm	dec	bx

planeloop:

asm	mov	di,[WORD PTR dest]

asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb
asm	add	di,bx
asm	movsb

asm	mov	ax,[planesize]
asm	add	[WORD PTR dest],ax

asm	loop	planeloop

asm	mov	ax,ss
asm	mov	ds,ax

}
#endif

#if GRMODE == CGAGR
void MemDrawChar (int char8,byte far *dest,unsigned width,unsigned planesize)
{
asm	mov	si,[char8]
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1
asm	shl	si,1		// index into char 8 segment

asm	mov	ds,[WORD PTR grsegs+STARTTILE8*2]
asm	mov	es,[WORD PTR dest+2]

asm	mov	bx,[width]
asm	sub	bx,2

asm	mov	di,[WORD PTR dest]

asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw
asm	add	di,bx
asm	movsw

asm	mov	ax,ss
asm	mov	ds,ax

	planesize++;		// shut the compiler up
}
#endif


/*
====================
=
= ShiftScore
=
====================
*/
#if GRMODE == EGAGR
void ShiftScore (void)
{
	spritetabletype far *spr;
	spritetype _seg *dest;

	spr = &spritetable[SCOREBOXSPR-STARTSPRITES];
	dest = (spritetype _seg *)grsegs[SCOREBOXSPR];

	CAL_ShiftSprite (FP_SEG(dest),dest->sourceoffset[0],
		dest->sourceoffset[1],spr->width,spr->height,2);

	CAL_ShiftSprite (FP_SEG(dest),dest->sourceoffset[0],
		dest->sourceoffset[2],spr->width,spr->height,4);

	CAL_ShiftSprite (FP_SEG(dest),dest->sourceoffset[0],
		dest->sourceoffset[3],spr->width,spr->height,6);
}
#endif

/*
===============
=
= CK_UpdateScoreBox
=
===============
*/

void CK_UpdateScoreBox (CK_object *ob)
{
	char		str[10],*ch;
	spritetype	_seg	*block;
	byte		far *dest;
	unsigned	i, length, width, planesize, number;
	boolean 	updated = false;

	// Don't draw anything for the high score level
	if (ck_inHighScores)
		return;

	// Show the demo sign for the demo mode
	if (DemoMode)
	{
		CK_DemoSign(ob);
		return;
	}

	if (!showscorebox)
		return;
//
// score changed
//
	if ((ck_gameState.keenScore>>16) != ob->user1
		|| (unsigned)ck_gameState.keenScore != ob->user2 )
	{
		block = (spritetype _seg *)grsegs[SCOREBOXSPR];
		width = block->width[0];
		planesize = block->planesize[0];
		dest = (byte far *)grsegs[SCOREBOXSPR]+block->sourceoffset[0]
			+ planesize + width*4 + 1*CHARWIDTH;

		ltoa (ck_gameState.keenScore,str,10);

		// erase leading spaces
		length = strlen(str);
		for (i=8;i>length;i--)
			MemDrawChar (41,dest+=CHARWIDTH,width,planesize);

		// draw digits
		ch = str;
		while (*ch)
			MemDrawChar (*ch++ - '0'+42,dest+=CHARWIDTH,width,planesize);

#if GRMODE == EGAGR
		ShiftScore ();
#endif
		updated = true;
		ob->user1 = ck_gameState.keenScore>>16;
		ob->user2 = ck_gameState.keenScore;
	}

//
// shots changed
//
	number = ck_gameState.numShots;
	if (number != ob->user3)
	{
		block = (spritetype _seg *)grsegs[SCOREBOXSPR];
		width = block->width[0];
		planesize = block->planesize[0];
		dest = (byte far *)grsegs[SCOREBOXSPR]+block->sourceoffset[0]
			+ planesize + width*20 + 7*CHARWIDTH;

		if (number > 99)
			strcpy (str,"99");
		else
			ltoa (number,str,10);

		// erase leading spaces
		length = strlen(str);
		for (i=2;i>length;i--)
			MemDrawChar (41,dest+=CHARWIDTH,width,planesize);

		// draw digits
		ch = str;
		while (*ch)
			MemDrawChar (*ch++ - '0'+42,dest+=CHARWIDTH,width,planesize);

#if GRMODE == EGAGR
		ShiftScore ();
#endif
		updated = true;
		ob->user3 = ck_gameState.numShots;
	}

//
// lives changed
//
	number = ck_gameState.numLives;
	if (number != ob->user4)
	{
		block = (spritetype _seg *)grsegs[SCOREBOXSPR];
		width = block->width[0];
		planesize = block->planesize[0];
		dest = (byte far *)grsegs[SCOREBOXSPR]+block->sourceoffset[0]
			+ planesize + width*20 + 2*CHARWIDTH;

		if (number > 99)
			strcpy (str,"99");
		else
			ltoa (number,str,10);

		// erase leading spaces
		length = strlen(str);
		for (i=2;i>length;i--)
			MemDrawChar (41,dest+=CHARWIDTH,width,planesize);

		// draw digits
		ch = str;
		while (*ch)
			MemDrawChar (*ch++ - '0'+42,dest+=CHARWIDTH,width,planesize);

#if GRMODE == EGAGR
		ShiftScore ();
#endif
		updated = true;
		ob->user4 = ck_gameState.numLives;
	}

	if (originxglobal != ob->posX || originyglobal != ob->posY)
	{
		ob->posX = originxglobal;
		ob->posY = originyglobal;
		updated = true;
	}


	if (updated)
#if GRMODE == EGAGR
	RF_PlaceSprite (&ob->sde
		,ob->posX+4*PIXGLOBAL
		,ob->posY+4*PIXGLOBAL
		,SCOREBOXSPR
		,spritedraw
		,PRIORITIES-1);
#endif

#if GRMODE == CGAGR
	RF_PlaceSprite (&ob->sde
		,ob->posX+8*PIXGLOBAL
		,ob->posY+8*PIXGLOBAL
		,SCOREBOXSPR
		,spritedraw
		,PRIORITIES-1);
#endif
}




//===========================================================================

// Contains some keen-5 specific functions.

//StartSprites + 
unsigned CK5_ItemSpriteChunks[] ={
	REDGEM1SPR, YELLOWGEM1SPR, BLUEGEM1SPR, GREENGEM1SPR,
	POINTS100ITEM1SPR, POINTS200ITEM1SPR, POINTS500ITEM1SPR, POINTS1000ITEM1SPR, POINTS2000ITEM1SPR, POINTS5000ITEM1SPR,
	ITEM1UP1SPR, ITEMSTUNNER1SPR, ITEM3UP1SPR
};


void CK_Think(CK_object *obj)
{

}

// Think function for adding gravity

void CK_Fall(CK_object *obj)
{
	CK_PhysGravityHigh(obj);
	ck_nextX = obj->velX * tics;
}

// Think function for adding a slightly lower amount of gravity

void CK_Fall2(CK_object *obj)
{
	CK_PhysGravityMid(obj);
	ck_nextX = obj->velX * tics;
}

void CK_Glide(CK_object *obj)
{
	ck_nextX = obj->velX * tics;
	ck_nextY = obj->velY * tics;
}

void CK_ObjBadState (void) {
	Quit("Object with bad state!");
}

void CK_BasicDrawFunc1(CK_object *obj)
{
	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, false, obj->zLayer);
}

/*
 * For walking and turning around at edges 
 */
void CK_BasicDrawFunc2(CK_object *obj)
{
	// Hit wall walking right; turn around and go left
	if (obj->xDirection == motion_Right && obj->leftTI != 0)
	{
		obj->posX -= obj->deltaPosX;
		obj->xDirection = motion_Left;
		obj->timeUntillThink = US_RndT() / 32;
		CK_SetAction2(obj, obj->currentAction);
	}
		// Hit wall walking left; turn around and go right
	else if (obj->xDirection == motion_Left && obj->rightTI != 0)
	{
		obj->posX -= obj->deltaPosX;
		obj->xDirection = motion_Right;
		obj->timeUntillThink = US_RndT() / 32;
		CK_SetAction2(obj, obj->currentAction);
	}
		// Walked off of ledge; turn around
	else if (obj->topTI == 0)
	{
		obj->posX -= obj->deltaPosX;
		obj->xDirection = -obj->xDirection;
		obj->timeUntillThink = US_RndT() / 32;
		CK_SetAction2(obj, obj->currentAction);
	}

	RF_PlaceSprite(&(obj->sde), obj->posX, obj->posY, obj->gfxChunk, false, obj->zLayer);
}

/*
 * Think function for stunned creatures
 */
void CK_BasicDrawFunc4(CK_object *obj)
{
	int starsX, starsY;

	// Handle physics
	if (obj->leftTI || obj->rightTI)
	{
		obj->velX = 0;
	}

	if (obj->bottomTI)
	{
		obj->velY = 0;
	}

	if (obj->topTI)
	{
		obj->velX = obj->velY = 0;
		if (obj->currentAction->next)
		{
			CK_SetAction2(obj, obj->currentAction->next);
		}
	}

	// Draw the primary chunk
	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, false, obj->zLayer);


	// Draw the stunner stars, offset based on the initial type of the stunned
	// critter

	starsX = starsY = 0;

	switch (obj->user4)
	{
	case CT_DartFrog:
		starsY -= 0x80;
		break;

	case CT_Atroxite:
		starsY -= 0x40;
		starsX += 0x60;
		break;

	case CT_Larvac:
		starsY -= 0x40;
		starsX += 0x60;
		break;


	}

	// Tick the star 3-frame animation forward
	if ((obj->user1 += tics) > 10)
	{
		obj->user1 -= 10;
		if (++obj->user2 >= 3)
			obj->user2 = 0;
	}

	// FIXME: Will cause problems on 64-bit systems
	RF_PlaceSprite((void **)&obj->user3, obj->posX + starsX, obj->posY + starsY, obj->user2 + STUNNEDSTARS1SPR, false, 3);
}

void CK_RemoveOnContact(CK_object *obj)
{
	if (obj->topTI || obj->rightTI || obj->bottomTI || obj->leftTI)
	{
		CK_RemoveObj(obj);
		return;
	}

	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, false, obj->zLayer);
}

void CK_StunCreature(CK_object *creature, CK_object *stunner, CK_action *new_creature_act)
{
	// Kill the stunner shot
	CK_ShotHit(stunner);

	// Set stunned creature action
	creature->user1 = creature->user2 = creature->user3 = 0;
	creature->user4 = creature->type;
	CK_SetAction2(creature, new_creature_act);
	creature->type = CT_StunnedCreature;

	// Make the creature jump up a bit
	if ((creature->velY -= 0x18) < -0x30)
		creature->velY = -0x30;

	// K1n9_Duk3 fix:
	creature->timeUntillThink = 0;	// allow it to jump without delay
}

void CK5_PointItem(CK_object *obj)
{
	//	obj->timeUntillThink = 20;
	obj->visible = true;
	if (++obj->gfxChunk == obj->user3)
		obj->gfxChunk = obj->user2;
}

void CK5_RedAxisPlatform(CK_object *obj)
{
	unsigned nextPosUnit, nextPosTile;

	if (ck_nextX || ck_nextY)
	{
		return;
	}
	//TODO: Implement properly.
	ck_nextX = obj->xDirection * 12 * tics;
	ck_nextY = obj->yDirection * 12 * tics;

	if (obj->xDirection == 1)
	{
		nextPosUnit = obj->clipRects.unitX2 + ck_nextX;
		nextPosTile = nextPosUnit >> 8;
		if (obj->clipRects.tileX2 != nextPosTile && 
		 *(mapsegs[2] + (mapwidth * obj->clipRects.tileY1 + nextPosTile)) == 0x1F)
		{
			obj->xDirection = -1;
			//TODO: Change DeltaVelocity
			ck_nextX -= (nextPosUnit & 255);
		}
	}
	else if (obj->xDirection == -1)
	{
		nextPosUnit = obj->clipRects.unitX1 + ck_nextX;
		nextPosTile = nextPosUnit >> 8;
		if (obj->clipRects.tileX1 != nextPosTile && 
		 *(mapsegs[2] + (mapwidth * obj->clipRects.tileY1 + nextPosTile)) == 0x1F)
		{
			obj->xDirection = 1;
			//TODO: Change DeltaVelocity
			//CK_PhysUpdateX(obj, 256 - nextPosUnit&255);
			ck_nextX += (256 - nextPosUnit) & 255;
		}
	}
	else if (obj->yDirection == 1)
	{
		nextPosUnit = obj->clipRects.unitY2 + ck_nextY;
		nextPosTile = nextPosUnit >> 8;
		if (obj->clipRects.tileY2 != nextPosTile && 
		 *(mapsegs[2] + (mapwidth * nextPosTile + obj->clipRects.tileX1)) == 0x1F)
		{
			if (CA_TileAtPos(obj->clipRects.tileX1, nextPosTile - 2, 2) == 0x1F)
			{
				//Stop the platform.
				obj->visible = true;
				ck_nextY = 0;
			}
			else
			{
				obj->yDirection = -1;
				//TODO: Change DeltaVelocity
				ck_nextY -= ( nextPosUnit & 255);
			}
		}
	}
	else if (obj->yDirection == -1)
	{
		nextPosUnit = obj->clipRects.unitY1 + ck_nextY;
		nextPosTile = nextPosUnit >> 8;
		if (obj->clipRects.tileY1 != nextPosTile && 
		 *(mapsegs[2] + (mapwidth * nextPosTile + obj->clipRects.tileX1)) == 0x1F)
		{
			if (CA_TileAtPos(obj->clipRects.tileX1, nextPosTile + 2, 2) == 0x1F)
			{
				// Stop the platform.
				obj->visible = true;
				ck_nextY = 0;
			}
			else
			{
				obj->yDirection = 1;
				//TODO: Change DeltaVelocity
				ck_nextY +=  256 - (nextPosUnit & 255);
			}
		}
	}
}

void CK_DeadlyCol(CK_object *o1, CK_object *o2)
{
	if (o2->type == CT_Stunner)
	{
		CK_ShotHit(o2);
	}
	else if (o2->type == CT_Player)
	{
		CK_KillKeen();
	}
}

void CK_DeadlyCol2(CK_object *o1, CK_object *o2)
{
	if (o2->type == CT_Player)
	{
		CK_KillKeen();
	}
}

void CK5_SpawnFallPlat(int tileX, int tileY)
{
	CK_object *new_object = CK_GetNewObj(false);
	new_object->type = CT_Platform;
	new_object->active = OBJ_ALWAYS_ACTIVE;
	new_object->zLayer = 0;
	new_object->posX = tileX << 8;
	new_object->user1 = new_object->posY = tileY << 8;
	new_object->xDirection = motion_None;
	new_object->yDirection = motion_Down;
	new_object->clipped = CLIP_not;
	CK_SetAction(new_object, &CK5_ACT_FallPlat0);
}

void CK5_FallPlatSit (CK_object *obj)
{

	if (obj == ck_keenState.platform)
	{
		ck_nextY = tics * 16;
		obj->velY = 0;
		if ((unsigned)(obj->posY + ck_nextY - obj->user1) >= 0x80)
			obj->currentAction = &CK5_ACT_FallPlat1;
	}
}

void CK5_FallPlatFall (CK_object *obj)
{
	unsigned newY, newYT;

	CK_PhysGravityHigh(obj);

	// K1n9_Duk3 fix: never move 15 pixels or more in one step (avoid moving through blocking tiles)
	if (ck_nextY >= 15*PIXGLOBAL)
		ck_nextY = 15*PIXGLOBAL;

	newY = obj->clipRects.unitY2 + ck_nextY;
	newYT = newY >> 8;

	// Stop falling if platform hits a block
	if ((obj->clipRects.tileY2 != newYT) && (CA_TileAtPos(obj->clipRects.tileX1, newYT, 2) == 0x1F))
	{
		ck_nextY = 0xFF - (obj->clipRects.unitY2 & 0xFF);
		if (ck_keenState.platform != obj)
			obj->currentAction = &CK5_ACT_FallPlat2;
	}
}

void CK5_FallPlatRise (CK_object *obj)
{
	if (ck_keenState.platform == obj)
	{
		obj->velY = 0;
		obj->currentAction = &CK5_ACT_FallPlat1;
	}
	else if ((unsigned) obj->posY <= (unsigned) obj->user1)
	{
		ck_nextY = obj->user1 - obj->posY;
		obj->currentAction = &CK5_ACT_FallPlat0;
	}
}

void CK5_SpawnItem(int tileX, int tileY, int itemNumber)
{

	CK_object *obj = CK_GetNewObj(false);

	obj->clipped = CLIP_not;
	//obj->active = OBJ_ACTIVE;
	obj->zLayer = 2;
	obj->type = CT_Item;	
	obj->posX = tileX << 8;
	obj->posY = tileY << 8;
	obj->yDirection = -1;
	obj->user1 = itemNumber;
	obj->gfxChunk = CK5_ItemSpriteChunks[itemNumber];
	obj->user2 = obj->gfxChunk;
	if (itemNumber == 12)
	{
		obj->user3 = obj->gfxChunk + 3;
		CK_SetAction(obj, &AR_ACT_3UP);
	}
	else
	{
		obj->user3 = obj->gfxChunk + 2;
		CK_SetAction(obj, &CK5_act_item);
	}



}

void CK5_SpawnAxisPlatform(int tileX, int tileY, int direction)
{
	CK_object *obj = CK_GetNewObj(false);

	obj->type = CT_Platform;
	obj->active = OBJ_ALWAYS_ACTIVE;
	obj->zLayer = 0;
	obj->posX = tileX << 8;
	obj->posY = tileY << 8;

	switch (direction)
	{
	case 0:
		obj->xDirection = 0;
		obj->yDirection = -1;
		break;
	case 1:
		obj->xDirection = 1;
		obj->yDirection = 0;
		break;
	case 2:
		obj->xDirection = 0;
		obj->yDirection = 1;
		break;
	case 3:
		obj->xDirection = -1;
		obj->yDirection = 0;
		break;
	}

	CK_SetAction(obj, &CK5_act_redAxisPlatform);
	//obj->gfxChunk = obj->currentAction->chunkLeft;

	CK_ResetClipRects(obj);
}

void CK5_SpawnRedStandPlatform(int tileX, int tileY)
{
	CK_object *obj = CK_GetNewObj(false);

	obj->type = CT_Platform;
	obj->active = OBJ_ACTIVE;
	obj->zLayer = 0;
	obj->posX = tileX << 8;
	obj->posY = obj->user1 = tileY << 8;
	obj->xDirection = 0;
	obj->yDirection = 1;
	obj->clipped = CLIP_not;
	CK_SetAction(obj, &CK5_ACT_redStandPlatform);
	//obj->gfxChunk = obj->currentAction->chunkLeft;
	CK_ResetClipRects(obj);
}



#define KEENLUMP 0
#define MAPKEENLUMP 1
#define PLATFORMLUMP 2
#define LARVACLUMP 3
#define BEETLELUMP 4
#define MAGMINELUMP 5
#define FIREBALLLUMP 6
#define DARTFROGLUMP 7
#define SPLIDERLUMP 8
#define LARVBATLUMP 9
#define ATROXIANLUMP 10
#define ATROXITELUMP 11
#define AXOCLAW1LUMP 12
#define AXOCLAW2LUMP 13
#define HORNETLUMP 14
#define MOXELLUMP 15
#define MOXELSHOTLUMP 16
#define KRILEGUARDIANLUMP 17
#define KRILEGUARDIANSHOTLUMP 18
#define KRILEGHOSTLUMP 19
#define	AXOSISLUMP 20
#define MAPKEEN2LUMP 21
#define DARTLUMP 22
#define SMALLEXPOSIONLUMP 23
#define MAGMINEEXPLOSIONLUMP 24
#define GENERATORLUMP 25
#define ELDERLUMP 26
#define BRIDGELUMP 27
#define CHECKPOINTLUMP 28
#define	KEENVINESLUMP 29
#define AXOSIS2LUMP 30
#define ATROXUSLUMP 31

#define NUMLUMPS 40

int ck_lumpsNeeded[NUMLUMPS];

int ck_lumpStarts[] = {
	KEEN_LUMP_START,
	WORLDKEEN_LUMP_START,
	PLATFORM_LUMP_START,
	LARVAC_LUMP_START,
	BEETLE_LUMP_START,
	MAGMINE_LUMP_START,
	FIREBALL_LUMP_START,
	DARTFROG_LUMP_START,
	SPLIDER_LUMP_START,
	LARVBAT_LUMP_START,
	ATROXIAN_LUMP_START,
	ATROXITE_LUMP_START,
	AXOCLAW1_LUMP_START,
	AXOCLAW2_LUMP_START,
	HORNET_LUMP_START,
	MOXEL_LUMP_START,
	MOXELSHOT_LUMP_START,
	KRILEGUARDIAN_LUMP_START,
	KRILEGUARDIANSHOT_LUMP_START,
	KRILEGHOST_LUMP_START,
	AXOSIS_LUMP_START,
	MAPKEEN2_LUMP_START,
	DART_LUMP_START,
	SMALLEXPOSION_LUMP_START,
	MAGMINEEXPLOSION_LUMP_START,
	GENERATOR_LUMP_START,
	ELDER_LUMP_START,
	BRIDGE_LUMP_START,
	CHECKPOINT_LUMP_START,
	KEENVINES_LUMP_START,
	AXOSIS2_LUMP_START,
	ATROXUS_LUMP_START,

};

int ck_lumpEnds[] = {
	KEEN_LUMP_END,
	WORLDKEEN_LUMP_END,
	PLATFORM_LUMP_END,
	LARVAC_LUMP_END,
	BEETLE_LUMP_END,
	MAGMINE_LUMP_END,
	FIREBALL_LUMP_END,
	DARTFROG_LUMP_END,
	SPLIDER_LUMP_END,
	LARVBAT_LUMP_END,
	ATROXIAN_LUMP_END,
	ATROXITE_LUMP_END,
	AXOCLAW1_LUMP_END,
	AXOCLAW2_LUMP_END,
	HORNET_LUMP_END,
	MOXEL_LUMP_END,
	MOXELSHOT_LUMP_END,
	KRILEGUARDIAN_LUMP_END,
	KRILEGUARDIANSHOT_LUMP_END,
	KRILEGHOST_LUMP_END,
	AXOSIS_LUMP_END,
	MAPKEEN2_LUMP_END,
	DART_LUMP_END,
	SMALLEXPOSION_LUMP_END,
	MAGMINEEXPLOSION_LUMP_END,
	GENERATOR_LUMP_END,
	ELDER_LUMP_END,
	BRIDGE_LUMP_END,
	CHECKPOINT_LUMP_END,
	KEENVINES_LUMP_END,
	AXOSIS2_LUMP_END,
	ATROXUS_LUMP_END,
};

extern int ck_lastLevelFinished;
void CK5_ScanInfoLayer()
{

	CK_object *obj;
	int x, y, infoValue, i,j;
	int mapW = mapwidth;
	int mapH = mapheight;

	memset(ck_lumpsNeeded, 0, sizeof(ck_lumpsNeeded));

	// AR HACK 
	ck_gameState.axosisNum = 0;
	ck_gameState.krileGhost = NULL;

	for (y = 0; y < mapH; ++y)
	{
		for (x = 0; x < mapW; ++x)
		{
			infoValue = *(mapsegs[2]+y * mapW + x);
			switch (infoValue)
			{
				// Keen
			case 1:
			case 2:
				CK_SpawnKeen(x, y, infoValue==2?motion_Left:motion_Right);
				grneeded[SCOREBOXSPR] |= ca_levelbit;
				ck_lumpsNeeded[KEENLUMP] = true;
				SpawnScore();

				if (mapon == 10)
					ck_lumpsNeeded[KEENVINESLUMP] = true;

				break;

			case 3:

				ck_lumpsNeeded[MAPKEENLUMP] = true;
				ck_lumpsNeeded[MAPKEEN2LUMP] = true;

				SpawnScore();
				grneeded[SCOREBOXSPR] |= ca_levelbit;
				if (ck_lastLevelFinished == 15)
					break;

				CK_SpawnMapKeen(x, y);
				break;

			case 4:
				AR_SpawnGenerator(x, y);
				ck_lumpsNeeded[GENERATORLUMP] = true;
				//ck_lumpsNeeded[SMALLEXPOSIONLUMP] = true;
				break;

				// Krile Elder
			case 6:
				AR_SpawnElder(x,y);
				CA_MarkGrChunk(ELDER2SPR);
				break;

			case 37:
				if (ck_lastLevelFinished == 15)
				{
					AR_SpawnTransporterKeen(x,y);
					ck_lumpsNeeded[MAPKEENLUMP] = true;
					ck_lumpsNeeded[MAPKEEN2LUMP] = true;
					SpawnScore();
					grneeded[SCOREBOXSPR] |= ca_levelbit;
				}
				break;


			// BWB Krile
			case 38:
				AR_SpawnBWBElder(x,y);
				CA_MarkGrChunk(ELDER1SPR);
				break;

			// Atroxus
			case 39:
				AR_SpawnAtroxusDialogue(x,y);
				CA_MarkGrChunk(ATROXUSDETECTSPR);
				break;

			// Secret Krile
			case 40:
				AR_SpawnSecretKrile(x,y);
				CA_MarkGrChunk(ELDER1SPR);
				break;

			// Boss fight keen spawn
			case 41:
				CK_SpawnBossKeen(x,y,motion_Right);
				grneeded[SCOREBOXSPR] |= ca_levelbit;
				ck_lumpsNeeded[KEENLUMP] = true;
				SpawnScore();
				break;

			// Krile Guardian
			case 50:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 49:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 5:

				AR_SpawnKrileGuardian(x, y);
				ck_lumpsNeeded[KRILEGUARDIANLUMP] = true;
				ck_lumpsNeeded[KRILEGUARDIANSHOTLUMP] = true;
				CA_MarkGrChunk(SPR_GUARDSHOTDIE1);
				CA_MarkGrChunk(SPR_GUARDSHOTDIE2);
				break;

			// Hornet
			case 52:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 51:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 7:

				AR_SpawnHornet(x, y);
				ck_lumpsNeeded[HORNETLUMP] = true;
				break;

			case 9:
				AR_SpawnAxoclaw(x, y);
				ck_lumpsNeeded[AXOCLAW1LUMP] = true;
				ck_lumpsNeeded[AXOCLAW2LUMP] = true;
				break;

			case 11:
				AR_SpawnMagmine(x,y);
				ck_lumpsNeeded[MAGMINELUMP] = true;
				break;
			case 12:
				AR_SpawnDartfrog(x,y);
				ck_lumpsNeeded[DARTFROGLUMP] = true;
				break;

			case 48:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 47:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 14:
				AR_SpawnAtroxite(x,y);
				ck_lumpsNeeded[ATROXITELUMP] = true;
				break;


			case 15:
				AR_SpawnAtroxus(x,y);
				ck_lumpsNeeded[ATROXUSLUMP] = true;
				ck_lumpsNeeded[SMALLEXPOSIONLUMP] = true;
				ck_lumpsNeeded[MAGMINEEXPLOSIONLUMP] = true;
				CA_MarkGrChunk(ABOMB1SPR);
				CA_MarkGrChunk(ABOMB2SPR);
				CA_MarkGrChunk(ATROXUSDROPBOMB1SPR);
				CA_MarkGrChunk(ATROXUSDROPBOMB2SPR);
				CA_MarkGrChunk(ATROXUSDEBRIS1SPR);
				CA_MarkGrChunk(ATROXUSDEBRIS2SPR);
				break;

			//Moxel
			case 24:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 23:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 17:
				AR_SpawnMoxel(x,y);
				ck_lumpsNeeded[MOXELLUMP] = true;
				ck_lumpsNeeded[MOXELSHOTLUMP] = true;
				break;

			// Krile Ghost
			case 18:
				AR_SpawnKrileGhost(x,y);
				ck_lumpsNeeded[KRILEGHOSTLUMP] = true;
				break;

			case 19:
				AR_SpawnSplider(x,y);
				ck_lumpsNeeded[SPLIDERLUMP] = true;
				break;
				
			// Axosis
			case 74:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 73:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 20:
				AR_SpawnAxosis(x,y);
				ck_lumpsNeeded[AXOSISLUMP] = true;
				ck_lumpsNeeded[AXOSIS2LUMP] = true;
				break;

			case 21:
				AR_SpawnBeetle(x,y);
				ck_lumpsNeeded[BEETLELUMP] = true;
				break;


			case 44:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 43:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 22:
				AR_SpawnLarvac(x,y);
				ck_lumpsNeeded[LARVACLUMP] = true;
				break;



			case 25:
				RF_SetScrollBlock(x,y,true);
				break;
			case 26:
				RF_SetScrollBlock(x,y,false);
				break;

			case 27:
			case 28:
			case 29:
			case 30:
				CK5_SpawnAxisPlatform(x,y,infoValue-27);
				ck_lumpsNeeded[PLATFORMLUMP] = true;
				break;


			case 32:
				CK5_SpawnFallPlat(x,y);
				ck_lumpsNeeded[PLATFORMLUMP] = true;
				break;

			case 34:
				if (ck_gameState.numShots < 5)
					CK5_SpawnItem(x,y,11);	
				break;

			case 35:
				AR_SpawnBridge(x,y);
				ck_lumpsNeeded[BRIDGELUMP] = true;
				break;

			case 46:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 45:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 8:
				AR_SpawnLarvbat(x,y);
				ck_lumpsNeeded[LARVBATLUMP] = true;
				// TODO: Put all larvbat graphics in a lump!
				CA_MarkGrChunk(SPR_LARVBATDIE1);
				CA_MarkGrChunk(SPR_LARVBATDIE2);
				CA_MarkGrChunk(SPR_LARVBATDIE3);
				CA_MarkGrChunk(SPR_LARVBATDIE4);

				break;

			case 53:
			case 54:
			case 55:
			case 56:
				AR_SpawnDartgun(x,y,infoValue-53);
				ck_lumpsNeeded[DARTLUMP] = true;
				break;

			case 79:
			case 80:
			case 81:
			case 82:
				if (ck_gameState.difficulty >= D_Normal)
				{
					AR_SpawnDartgun(x,y,infoValue-79);
					ck_lumpsNeeded[DARTLUMP] = true;
				}
				break;
			case 83:
			case 84:
			case 85:
			case 86:
				if (ck_gameState.difficulty >= D_Hard)
				{
					AR_SpawnDartgun(x,y,infoValue-83);
					ck_lumpsNeeded[DARTLUMP] = true;
				}
				break;

			case 87:
				AR_SpawnAtroxusBox(x,y);
				CA_MarkGrChunk(ATROXUSDETECTSPR);
				break;

			case 69:
				CA_MarkGrChunk(ITEM3UP1SPR);
				CA_MarkGrChunk(ITEM3UP2SPR);
				CA_MarkGrChunk(ITEM3UP3SPR);
			case 57:
			case 58:
			case 59:
			case 60:
			case 61:
			case 62:
			case 63:
			case 64:
			case 65:
			case 66:
			case 67:
			case 68:
				CK5_SpawnItem(x,y,infoValue-57);	
				break;

			
			case 70:
			case 71:
			case 72:
				AR_SpawnFireball(x,y,infoValue-70);
				ck_lumpsNeeded[FIREBALLLUMP] = true;
				break;

			case 78:
				if (ck_gameState.difficulty < D_Hard)
					break;
			case 77:
				if (ck_gameState.difficulty < D_Normal)
					break;
			case 76:
				AR_SpawnAtroxian(x,y);
				ck_lumpsNeeded[ATROXIANLUMP] = true;
				ck_lumpsNeeded[SMALLEXPOSIONLUMP] = true;
				ck_lumpsNeeded[MAGMINEEXPLOSIONLUMP] = true;
				CA_MarkGrChunk(SPR_ATROXIANDEAD);
				break;


				// Checkpoints
			case 42:
				AR_SpawnCheckPoint(x,y);
				ck_lumpsNeeded[CHECKPOINTLUMP] = true;
				break;


			}
		}
	}

	// Inactivate all objects
	for (obj = ck_keenObj; obj != NULL; obj = obj->next)
	{
		if (obj->active != OBJ_ALWAYS_ACTIVE)
			obj->active = OBJ_INACTIVE;
		// ARHACK
		// set axosis
		if (ck_gameState.krileGhost)
		{
			if (obj->type == CT_Axosis && obj->user1 == 0)
			{
				ck_gameState.krileGhost->user4 = (unsigned)obj;
			}
		}
	}


	// Cache chunks
	for (i = 0; i < NUMLUMPS; i++)
	{
		if (!ck_lumpsNeeded[i])
			continue;

		for (j = ck_lumpStarts[i]; j <= ck_lumpEnds[i]; j++)
		{
			grneeded[j] |= ca_levelbit;
		}
	}
	
}


//===========================================================================

// In-Level checkpoints

boolean ck_restartFromCheckpoint;
CK_action AR_ACT_CheckPointIdle;

CK_action AR_ACT_CheckPointSpin1;
CK_action AR_ACT_CheckPointSpin2;
CK_action AR_ACT_CheckPointSpin3;
CK_action AR_ACT_CheckPointSpin4;

CK_action AR_ACT_CheckPointShadow;
void AR_CheckPointCol(CK_object *obj1, CK_object *obj2);

CK_action AR_ACT_CheckPointIdle = {CHECKPOINTSPR, CHECKPOINTSPR, AT_UnscaledFrame, 0, 0, 8, 0, 0, NULL, AR_CheckPointCol, CK_BasicDrawFunc1, &AR_ACT_CheckPointIdle};

CK_action AR_ACT_CheckPointSpin1 = {CHECKPOINTSPIN1SPR, CHECKPOINTSPIN1SPR, AT_UnscaledFrame, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_CheckPointSpin2};
CK_action AR_ACT_CheckPointSpin2 = {CHECKPOINTSPIN2SPR, CHECKPOINTSPIN2SPR, AT_UnscaledFrame, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_CheckPointSpin3};
CK_action AR_ACT_CheckPointSpin3 = {CHECKPOINTSPIN3SPR, CHECKPOINTSPIN3SPR, AT_UnscaledFrame, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_CheckPointSpin4};
CK_action AR_ACT_CheckPointSpin4 = {CHECKPOINTSPIN4SPR, CHECKPOINTSPIN4SPR, AT_UnscaledFrame, 0, 0, 8, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_CheckPointSpin1};

CK_action AR_ACT_CheckPointShadow = {CHECKPOINTSHADOWSPR, CHECKPOINTSHADOWSPR, AT_ScaledOnce, 0, 0, 70, 0, 4, NULL, NULL, CK_BasicDrawFunc1, NULL};


boolean AR_SaveCheckpoint (CK_object *checkpoint)
{
	int handle, i;
	char filename[] = "CHKPOINT."EXTENSION;
	long savetime, savelast;
	CK_object *obj;

	// Pause the game
	savetime = TimeCount;
	savelast = lasttimecount;

#if 0
	VW_FixRefreshBuffer();
	US_CenterWindow(18, 3);
	US_PrintCentered("SAVING CHECKPOINT");
	VW_UpdateScreen(); 
	RF_ForceRefresh();
#endif
	
	handle = open(filename ,O_CREAT | O_BINARY | O_WRONLY,
				S_IREAD | S_IWRITE | S_IFREG);
	if (handle == -1)
	{
		close(handle);
		remove(filename);
		return false;
	}

	// Save the game state
	ck_keenState.platform = NULL;
	if (!CA_FarWrite(handle, (byte far *)&ck_gameState, sizeof (ck_gameState)))
		return false;

	// Save the uncompressed level
	for (i = 0; i < 3; i++)
	{
		if (!CA_FarWrite(handle, (byte _seg *)mapsegs[i], mapwidth * mapheight * 2))
			return false;
	}
	
	// Save the object list
	for (obj = ck_keenObj; obj; obj = obj->next)
	{
		CK_object saveobj;

		// Save a modified version of the Keen Object
		if (obj == ck_keenObj)
		{
			memcpy(&saveobj, ck_keenObj, sizeof (CK_object));
			saveobj.posX = checkpoint->posX;
			saveobj.posY = checkpoint->posY;
			obj = &saveobj;
		}


		if (!CA_FarWrite(handle, (byte far *)obj, sizeof(CK_object)))
		{
			return false;
		}
	}

	close (handle);

	TimeCount = savetime;
	lasttimecount = savelast;
	return true;
	

	
}

boolean AR_LoadCheckPoint (void)
{

	int handle, i; 
	unsigned bufsize, cmplen;
	memptr buf;
	CK_GameState oldstate;
	CK_object *objprev, *objnext, *more_obj, *new_object;
	char filename[] = "CHKPOINT."EXTENSION;

	handle = open(filename,O_BINARY | O_RDONLY);


	// Adjust the lives/score/ammo/other vars of gamestate that aren't affected
	// by checkpoints
	memcpy (&oldstate, &ck_gameState, sizeof(oldstate));

	// Read the game state
	if( !CA_FarRead( handle, (byte far *)&ck_gameState, sizeof (ck_gameState) ) )
		return false;
	
	ck_gameState.numShots = oldstate.numShots < 10? 10: oldstate.numShots;
	ck_gameState.numLives = oldstate.numLives;
	ck_gameState.numVitalin = oldstate.numVitalin;

	memcpy (&ck_gameState.endscreen_played, &oldstate.endscreen_played, sizeof(ck_gameState.endscreen_played));
	// Load in the level planes
#if 0
	ca_levelbit >>= 1;
	ca_levelnum--;
#endif
	// CK_LoadLevel(false);
#if 0
	if( mmerror ) {
		mmerror = 0;
		US_CenterWindow( 20, 8 );
		PrintY += 20;
		US_CPrint( "Not enough memory\nto load game!" );
		VW_UpdateScreen();
		IN_Ack();//wait_for_button();
		return false;
	}
	ca_levelbit <<= 1;
	ca_levelnum++;
#endif

	/* Read the level data from the file */
	for( i = 0; i < 3; i++ ) {
		if( !CA_FarRead( handle, (byte far *)mapsegs[i], mapwidth * mapheight * 2 ) ) {
			return false;	
		}
	}

	// Read the object array
	CK_SetupObjArray();
	ck_gameState.krileGhost = NULL;	// K1n9_Duk3 fix: always reset the pointer
	new_object = ck_keenObj;

	/* Read the first object (keen) from the list */
	objprev = new_object->prev;
	objnext = new_object->next;
	if( !CA_FarRead( handle, (byte far *)new_object, sizeof(CK_object) ) )
		return 0;
	new_object->prev = objprev;
	new_object->next = objnext;


	new_object->visible = 1;
	new_object->sde = NULL;

	// Set keen standing at the checkpoint
	CK_SpawnKeen(new_object->posX >> G_T_SHIFT, new_object->posY >> G_T_SHIFT, new_object->xDirection);


	new_object = ck_scoreBoxObj;

	while( 1 ) {
		/* Read the object from the file and put it in the list */
		objprev = new_object->prev;
		objnext = new_object->next;
		if( !CA_FarRead( handle, (byte far *)new_object, sizeof(CK_object) ) )
			return 0;
		more_obj = new_object->next;
		new_object->prev = objprev;
		new_object->next = objnext;

		new_object->visible = 1;
		new_object->sde = 0;

		if( new_object->type == CT_StunnedCreature ) {
			new_object->user3 = NULL;
		} else if( new_object->type == CT_Platform ) {
			new_object->user2 = new_object->user3 = 0;
		}
		// K1n9_Duk3 fix: this was missing!
		else if (new_object->type == CT_KrileGhost) {
			ck_gameState.krileGhost = new_object;
			new_object->user4 = 0;	// K1n9_Duk3 fix: always reset the ghost's next axosis pointer
		}

		/* If this is the last object in the saved list, exit the loop */
		if (!more_obj)
			break;

		/* Otherwise we add a new object */
		new_object = CK_GetNewObj( false );
	}

	ck_scoreBoxObj->user1 = -1;
	ck_scoreBoxObj->user2 = -1;
	ck_scoreBoxObj->user3 = -1;
	ck_scoreBoxObj->user4 = -1;
	
	// Set up Krile Ghost and axosis counts if there is one in the level
	if (ck_gameState.krileGhost)
	{
		for (more_obj = ck_keenObj; more_obj; more_obj = more_obj->next)
		{
			if (more_obj->type == CT_Axosis)
			{
				//ck_gameState.axosisNum++;	//K1n9_Duk3 fix: don't mess with this value!
				if (more_obj->user1 == ck_gameState.krileGhost->user3)
					ck_gameState.krileGhost->user4 = (unsigned)more_obj;
			}
		}
	}

	close(handle);
	return true;

}

void AR_SpawnCheckPoint (unsigned x, unsigned y)
{

	CK_object *obj = CK_GetNewObj(false);
	obj->type = CT_CheckPoint;
	obj->active = OBJ_ACTIVE;
	obj->zLayer = 0;
	obj->posX = x << 8;
	obj->posY = y << 8;
	obj->clipped = CLIP_not;
	CK_SetAction(obj, &AR_ACT_CheckPointIdle);
}

void AR_CheckPointCol (CK_object *obj1, CK_object *obj2)
{
	if (obj2->type == CT_Player && obj2->currentAction != &CK_ACT_keenDie0 && obj2->currentAction != &CK_ACT_keenDie1)
	{
		// K1n9_Duk3 fix:
		/*
		CK_object *newobj;

		ck_restartFromCheckpoint = true;
		CK_SetAction2(obj1, &AR_ACT_CheckPointSpin1);

		AR_SaveCheckpoint(obj1);

		newobj = CK_GetNewObj(true);
		newobj->type = CT_Friendly;
		newobj->active = OBJ_EXISTS_ONLY_ONSCREEN;
		newobj->clipped = CLIP_not;
		newobj->posX = obj1->posX - 0x80;
		newobj->posY = obj1->posY;
		newobj->yDirection = -1;
		newobj->zLayer = PRIORITIES - 1;
		CK_SetAction(newobj, &AR_ACT_CheckPointShadow);




		SD_PlaySound(CHECKPOINTSND);
		*/
		// Saving the checkpoint right here is a bad idea!
		//
		// This is a collision function, which is executed in the middle
		// of updating the actor objects. If we save right here, that will
		// leave some objects in a bad state after loading the checkpoint.
		// One example of bad things happening is the Magmine. If a Magmine
		// has just moved off a cliff when this code is executed, it relies
		// on its React function to move it back to its previous position.
		// But when you load the checkpoint, it loads the object in this
		// bad position and then makes it move again without ever fixing
		// the bad position.
		//
		// My solution is to use a global variable to indicate that the
		// player has just touched a checkpoint (I let it store either the
		// checkpoint object or a NULL pointer) and move all the checkpoint
		// code from here into the PlayLoop function to make sure the
		// checkpoint is saved after all objects have been updated
		// correctly.

		extern CK_object *touchedCheckpoint;
		touchedCheckpoint = obj1;
	}
}

