/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/////////////////////////////////////////////////
//
// MUSE Header for .CKD
// Created Mon Jul 01 18:21:23 1991
// Updated for ID Engine from Catacomb 3-D
//
/////////////////////////////////////////////////

#define NUMSOUNDS		52
#define NUMMUSIC		36
#define NUMSNDCHUNKS		140

//
// Sound names & indexes
//
typedef enum {
		KEENWALK1SND,             // 0				ok
		KEENWALK2SND,             // 1				ok
		JUMPSND,                  // 2				ok
		LANDSND,                  // 3
		THROWSND,                 // 4
		DIVESND,                  // 5
		SLUGPOOSND,               // 6				LarvacSlime.adl
		KEENPOGOSND,              // 7
		GOTITEMSND,               // 8
		GOTSTUNNERSND,            // 9
		GOTVITALINSND,            // 10
		ATROXIANGROUNDEDSND,      // 11				Atroxian Grounded.adl	?
		LEVELSTARTSND,            // 12
		LEVELDONESND,             // 13
		NOWAYSND,                 // 14
		KEENHITCEILINGSND,        // 15				
		DARTFROGJUMPSND,          // 16
		GOTEXTRALIFESND,          // 17
		OPENGEMDOORSND,           // 18
		GOTGEMSND,                // 19
		KEENFALLSND,              // 20
		KEENOUTOFAMMOSND,         // 21
		AXOSISSQUISHSND,          // 22				Axosis Squash.adl
		KEENDIESND,               // 23
		ATROXUSBOMBEXPLODESND,    // 24				Atroxus Bomb Explode.adl
		KEENSHOTHITSND,           // 25
		ATROXUSCHARGESND,         // 26				Atroxus Charging.adl?
		CHECKPOINTSND,            // 27				Checkpoint.adl
		KRILEGUARDTHROWSND,       // 28				Dark Krile Projectile Throw.adl
		GROWLSND,                 // 29				Enemy Growl.adl?
		KRILEGHOSTATTACKSND,      // 30				Ghost Attack.adl

		GENERATOREXPLODESND,      // 31				Generator Destroyed.adl
		ATROXITEATTACKSND,        // 32
		MAGMINEEXPLODESND,        // 33				Magmine Explode.adl
		STATUSDOWNSND,            // 34
		STATUSUPSND,              // 35
		SPLIDERSND,               // 36				Splider2.adl
		ATROXUSBOMBDROPSND,       // 37			        Atroxus Bomb Drop.adl	
		HORNETATTACKSND,          // 38				Hornet.adl
		AXOCLAWSHOOTSND,          // 39
		ATROXITESTUNNEDSND,       // 40				AtroxideStunned.adl
		DARTSHOOTSND,             // 41
		BEETLEJUMPSND,            // 42				BeetleboneJump.adl
		FLAGFLIPSND,              // 43
		FLAGLANDSND,              // 44
		SENTRYSHOOTSND,           // 45				SentryShoot.adl
		SENTRYSHOTIMPACTSND,      // 46				SentryShotImpact.adl
		KEENPADDLESND,            // 47
		BALLBOUNCESND,            // 48
		COMPPADDLESND,            // 49
		COMPSCOREDSND,            // 50
		KEENSCOREDSND,            // 51

		LASTSOUND
} soundnames;

#define		KEENWALK0SND  	0
#define		KEENWALK1SND          1
#define		KEENJUMPSND           2
#define		KEENLANDSND           3
#define		KEENSHOOTSND          4
#define		MINEEXPLODESND        5
#define		SLICEBUMPSND          6
#define		KEENPOGOSND           7
#define		GOTITEMSND            8
#define		GOTSTUNNERSND         9
#define		GOTVITALINSND         10
#define		UNKNOWN11SND          11
#define		UNKNOWN12SND          12
#define		LEVELEXITSND          13
#define		NEEDKEYCARDSND        14
#define		KEENHITCEILINGSND     15
#define		SPINDREDFLYUPSND      16
#define		GOTEXTRALIFESND       17
#define		OPENGEMDOORSND        18
#define		GOTGEMSND             19
#define		KEENFALLSND           20
#define		KEENOUTOFAMMOSND      21
#define		UNKNOWN22SND          22
#define		KEENDIESND            23
#define		UNKNOWN24SND          24
#define		KEENSHOTHITSND        25
#define		UNKNOWN26SND          26
#define		SPIROSLAMSND          27
#define		SPINDREDSLAMSND       28
#define		ENEMYSHOOTSND         29
#define		ENEMYSHOTHITSND       30
#define		AMPTONWALK0SND        31
#define		AMPTONWALK1SND        32
#define		AMPTONSTUNSND         33
#define		UNKNOWN34SND          34
#define		UNKNOWN35SND          35
#define		SHELLYEXPLODESND      36
#define		SPINDREDFLYDOWNSND    37
#define		MASTERSHOTSND         38
#define		MASTERTELESND         39
#define		POLEZAPSND            40
#define		UNKNOWN41SND          41
#define		SHOCKSUNDBARKSND      42
#define		UNKNOWN43SND          43
#define		UNKNOWN44SND          44
#define		BARKSHOTDIESND        45
#define		UNKNOWN46SND          46
#define		UNKNOWN47SND          47
#define		UNKNOWN48SND          48
#define		UNKNOWN49SND          49
#define		UNKNOWN50SND          50
#define		UNKNOWN51SND          51


//
// Base offsets
//
#define STARTPCSOUNDS		0
#define STARTADLIBSOUNDS	52
#define STARTDIGISOUNDS		104   // not present
#define STARTMUSIC		104

//
// Music names & indexes
//
typedef enum {
	WORLD_MAP_MUS,            // 0
	DARK_SWAMP_MUS,           // 1
	MURKY_MARSH_MUS,          // 2
	LARVAE_LAGOON_MUS,        // 3
	CRYSTALLITE_CAV_MUS,      // 4
	EMERALD_CANYON_MUS,       // 5
	ATROXIAN_MINES_MUS,       // 6
	ATROXIAN_BASE_MUS,        // 7
	SECURITY_LAYER_MUS,       // 8
	PORT_ATROX_MUS,           // 9
	HORNET_HIVE_MUS,          // 10
	BRITHOM_BOG_MUS,          // 11
	KRIDONEA_GATEWAY_MUS,     // 12
	ANCIENT_FOREST_MUS,       // 13
	CATACOMBS_MUS,            // 14
	GREAT_ZIGGURAT_MUS,       // 15
	SKY_SANCTUM_MUS,          // 16
	BOSS_MUS,                 // 17
	CRYSTAL_SHRINE_MUS,       // 18
	HSCORES_MUS,              // 19
	KRIDONEA_RUINS1_MUS,      // 20
	KRIDONEA_RUINS2_MUS,      // 21
	CARGO_TRANSITB_MUS,       // 22
	CARGO_TRANSITA_MUS,       // 23
	CRYSTALCOMB_HIVE_MUS,     // 24
	BWB_MUS,		// Level 25 Music
	TERMINATOR_MUS,           // 25
	HELP_MUS,                 // 26
	ENDING_MUS,               // 27
	SKY_SANCTUM_MAP_MUS,      // 28
	SCROLLING_STORY_MUS,      // 29
	ATROXUS_TEXT_MUS,         // 30
	ELDER_TEXT_MUS,           // 31
	KRILE_THEME_MUS,          // 32
	ATROXUS_BOX_MUS,	  // 33
	NORMAL_END_MUS,		  // 34
	LASTMUSIC
	     } musicnames;

/////////////////////////////////////////////////
//
// Thanks for playing with MUSE!
//
/////////////////////////////////////////////////




